package com.gree.mall.miniapp.bean.order;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.gree.mall.miniapp.plus.entity.Goods;
import com.gree.mall.miniapp.plus.entity.GoodsSpec;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@ApiModel
@Data
public class BuyGood {

    @ApiModelProperty("商品id")
    private String goodsId;
    @ApiModelProperty("商品规格id")
    private String GoodsSpecId;
    @ApiModelProperty("购买数量")
    private Integer num;
    @ApiModelProperty("套购商品-框几")
    private Integer popType;
    @ApiModelProperty("购物车id(购物车提交订单才传)")
    private String shoppingCartId;
    @ApiModelProperty("团购活动id")
    private String promotionGroupId;
    @ApiModelProperty("秒杀活动id")
    private String secKillId;
    @ApiModelProperty("wxSceneId")
    private String wxSceneId;

    @JsonIgnore
    private Goods goods;
    @JsonIgnore
    private GoodsSpec goodsSpec;
    @JsonIgnore
    @ApiModelProperty("单价")
    private BigDecimal price;
    @JsonIgnore
    @ApiModelProperty("单个商品佣金")
    private BigDecimal shareAmount;
    //套购商品
    @JsonIgnore
    private Boolean isGoodsPackage = false;
    //秒杀商品
    @JsonIgnore
    private Boolean isSecKill = false;
    //团购商品
    @JsonIgnore
    private Boolean isPromotionGroup = false;
    //原价
    @JsonIgnore
    private BigDecimal orgPrice;
    //活动的商品图
    @JsonIgnore
    private String promotionImgUrl;


}
