package com.gree.mall.miniapp.config.wx;

import lombok.RequiredArgsConstructor;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.api.impl.WxMpServiceImpl;
import me.chanjar.weixin.mp.config.impl.WxMpDefaultConfigImpl;
import me.chanjar.weixin.mp.config.impl.WxMpRedisConfigImpl;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * 微信公众号服务配置
 * @author qinrongjun
 */
@RequiredArgsConstructor
@Configuration
@EnableConfigurationProperties(WxMpProperties.class)
public class WxMpConfiguration {
    private final WxMpProperties wxMpProperties;

    @Bean
    public WxMpService wxMpService() {
        WxMpService service = new WxMpServiceImpl();
        WxMpDefaultConfigImpl myWxMpRedisConfig = new WxMpDefaultConfigImpl();
        myWxMpRedisConfig.setAppId(wxMpProperties.getAppId());
        myWxMpRedisConfig.setSecret(wxMpProperties.getSecret());
        service.setWxMpConfigStorage(myWxMpRedisConfig);
        return service;
    }
}
