package com.gree.mall.miniapp.controller.notice;

import com.alibaba.fastjson.JSONObject;
import com.gree.mall.miniapp.annotation.ApiNotAuth;
import com.gree.mall.miniapp.bean.notice.NoticeParam;
import com.gree.mall.miniapp.helper.ResponseHelper;
import com.gree.mall.miniapp.logic.common.GongdanLogic;
import com.gree.mall.miniapp.logic.notice.NoticeLogic;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.common.error.WxErrorException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@Api(value = "公众号模板通知API(V2)", tags ={"公众号模板通知API(V2)"} )
@RequestMapping(value = "/notice/v2", produces = "application/json; charset=utf-8")
public class NoticeV2Controller {

    @Autowired
    NoticeLogic noticeLogic;
    @Autowired
    GongdanLogic gongdanLogic;

    @ApiOperation("参数说明")
    @PostMapping("/a")
    public ResponseHelper pushA(
            @RequestBody NoticeParam bean
    ){
        return ResponseHelper.success();
    }


    @ApiNotAuth
    @ApiOperation("公众号提醒-通用接口")
    @PostMapping("/common")
    public ResponseHelper notice(
            @RequestBody JSONObject jsonObject
    ) throws WxErrorException {
        String content = (String)jsonObject.get("content");
        String iv = (String)jsonObject.get("iv");
        String s = gongdanLogic.checkSign(content, iv,null);
        NoticeParam bean = JSONObject.parseObject(s, NoticeParam.class);

        noticeLogic.addNotice(bean);
        return ResponseHelper.success();
    }

}
