package com.gree.mall.miniapp.controller.user;

import com.gree.mall.miniapp.exception.RemoteServiceException;
import com.gree.mall.miniapp.helper.ResponseHelper;
import com.gree.mall.miniapp.logic.user.WorkerLogic;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@Slf4j
@RestController
@Api(value = "申请成为业务员", tags ={"申请成为业务员"} )
@RequestMapping(value = "/worker", produces = "application/json; charset=utf-8")
public class WorkerController {
    @Autowired
    private WorkerLogic workerLogic;

    @PostMapping("/sms/send")
    @ApiOperation(value = "发送验证码")
    public ResponseHelper sendSms(
            HttpServletRequest request,
            @ApiParam(value = "手机号码",required = true) @RequestParam String phone,
            @ApiParam(value = "滑动验证key",required = false) @RequestParam(required = false) String key,
            @ApiParam(value = "滑动验证数值",required = false) @RequestParam(required = false) String vrifyCode
    ) throws Exception {
        workerLogic.sendSms(phone, key, vrifyCode, request);
        return ResponseHelper.success();
    }

    @PostMapping("/bind")
    @ApiOperation(value = "绑定业务员")
    public ResponseHelper<String> bind(
            HttpServletRequest request,
            @ApiParam(value = "手机号码",required = true) @RequestParam String phone,
            @ApiParam(value = "短信验证码",required = true) @RequestParam String code
    ) throws RemoteServiceException {

        workerLogic.bind(request, phone, code);
        return ResponseHelper.success("成功提交申请记录");
    }



}
