package com.gree.mall.miniapp.enums;

import cn.hutool.core.util.EnumUtil;
import lombok.Getter;

import java.util.Map;

@Getter
public enum UMSDiscountCodeEnum {
    GDYJKT(1, "一级能效空调", "GDYJKT", "A04"),
    GDEJKT(2, "二级能效空调", "GDEJKT", "A04"),
    GDYJDS(3, "一级能效电视", "GDYJDS", "A01"),
    GDEJDS(4, "二级能效电视", "GDEJDS", "A01"),
    GDYJBX(5, "一级能效冰箱", "GDYJBX", "A02"),
    GDEJBX(6, "二级能效冰箱", "GDEJBX", "A02"),
    GDYJXYJ(7, "一级能效洗衣机", "GDYJXYJ", "A03"),
    GDEJXYJ(8, "二级能效洗衣机", "GDEJXYJ", "A03"),
    GDYJXYYJ(9, "一级能效吸油烟机", "GDYJXYYJ", "A07"),
    GDEJXYYJ(10, "二级能效吸油烟机", "GDEJXYYJ", "A07"),
    GDYJDZ(11, "一级能效家用灶具", "GDYJDZ", "A08"),
    GDEJDZ(12, "二级能效家用灶具", "GDEJDZ", "A08"),
    GDYJRSQ(13, "一级能效热水器", "GDYJRSQ", "A06"),
    GDEJRSQ(14, "二级能效热水器", "GDEJRSQ", "A06"),
    GDYJDN(15, "一级能效电脑", "GDYJDN", "A05"),
    GDEJDN(16, "二级能效电脑", "GDEJDN", "A05"),
    GDYJCSJ(17, "一级能效除湿机", "GDYJCSJ", "GDYJKT"),
    GDEJCSJ(18, "二级能效除湿机", "GDEJCSJ", "GDYJKT"),
    GDYJJSQ(19, "一级能效净水器", "GDYJJSQ", "A10"),
    GDEJJSQ(20, "二级能效净水器", "GDEJJSQ", "A10"),
            ;

    UMSDiscountCodeEnum(Integer index, String name, String code, String category) {
        this.index = index;
        this.name = name;
        this.code = code;
        this.category = category;
    }

    private Integer index;
    private String name;
    private String code;
    private String category;

    public static String findNameByCode(String code) {
        final Map<String, Object> fieldMap = EnumUtil.getNameFieldMap(UMSDiscountCodeEnum.class, "name");
        return fieldMap.containsKey(code) ? fieldMap.get(code).toString() : "";
    }

    public static String findShortNameByCode(String code) {
        final Map<String, Object> fieldMap = EnumUtil.getNameFieldMap(UMSDiscountCodeEnum.class, "name");
        return fieldMap.containsKey(code) ? fieldMap.get(code).toString().substring(4) : "";
    }
}
