package com.gree.mall.miniapp.logic.member;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.additional.query.impl.LambdaQueryChainWrapper;
import com.gree.mall.miniapp.plus.entity.UserCoupon;
import com.gree.mall.miniapp.plus.service.UserCouponService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
public class UserCouponLogic {

    @Resource
    UserCouponService userCouponService;
    /**
     * 领取记录列表
     * @param couponName
     * @param couponType
     * @param pageNum
     * @param pageSize
     * @return
     */
    public IPage<UserCoupon> page(String couponName, String couponType, Integer pageNum, Integer pageSize) {
        final Page<UserCoupon> page = userCouponService.lambdaQuery()
                .like(StringUtils.isNotBlank(couponName), UserCoupon::getCouponName, couponName)
                .eq(StringUtils.isNotBlank(couponName), UserCoupon::getCouponType, couponType)
                .page(new Page<>(pageNum, pageSize));
        return page;
    }
}
