package com.gree.mall.miniapp.schedule;

import com.gree.mall.miniapp.enums.OrderStatusEnum;
import com.gree.mall.miniapp.logic.common.FucaiLogic;
import com.gree.mall.miniapp.plus.entity.OrderDetail;
import com.gree.mall.miniapp.plus.entity.OrderInfo;
import com.gree.mall.miniapp.plus.service.OrderDetailService;
import com.gree.mall.miniapp.plus.service.OrderInfoService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

@Slf4j
@Service
public class OrderJindSchedule {

    @Autowired
    OrderInfoService orderInfoService;
    @Autowired
    OrderDetailService orderDetailService;
    @Autowired
    FucaiLogic fucaiLogic;

   // @Scheduled(fixedDelay = 60 * 1000)
    public void task(){

        List<String> orderStatus = Arrays.asList(OrderStatusEnum.DFH.toString(), OrderStatusEnum.YFH.toString());
        //8.26号更新，只处理该日期之后的订单
        List<OrderInfo> list = orderInfoService.lambdaQuery()
                .ge(OrderInfo::getCreateTime, "2022-09-08 00:00:00")
                .eq(OrderInfo::getJindSaleStatus, false)
                .in(OrderInfo::getOrderStatus,orderStatus)
                .list();
        log.info("定时同步金蝶销售单数量:"+list.size());
        for(OrderInfo orderInfo : list){
            List<OrderDetail> orderDetails = orderDetailService.lambdaQuery().eq(OrderDetail::getOrderId, orderInfo.getOrderId()).list();
            //对接金蝶系统
        //    Boolean aBoolean = fucaiLogic.sendSaleOrder(orderDetails,orderInfo,orderInfo.getWebsitNumber());
         //   orderInfo.setJindSaleStatus(aBoolean);

            orderInfo.updateById();
        }
    }

}
